char WWW_UI[] = "\
set urilist {}\n\
set uriix -1\n\
\n\
proc webdisp {uri} {\n\
    global urilist uriix\n\
\n\
    catch {\n\
	toplevel .web\n\
	frame .web.f -borderwidth 2 -relief groove\n\
	pack .web.f -side top -fill both -expand true\n\
	text .web.f.c -width 80 -height 30 -wrap word \\\n\
	   -font \"-*-times-medium-r-normal--14-*\"\\\n\
	   -yscroll \".web.f.sb set\"\n\
	pack .web.f.c -side left -fill both -expand true\n\
	scrollbar .web.f.sb  -command \".web.f.c yview\" \\\n\
  -background [option get . scrollbarBackground Sdr] \n\
#TBD\n\
#  -foreground [option get . scrollbarForeground Sdr] \\\n\
#  -activeforeground [option get . scrollbarActiveForeground Sdr]\n\
	pack .web.f.sb -side right -fill y\n\
\n\
	frame .web.f0 -borderwidth 2 -relief groove\n\
	pack .web.f0 -side top -fill x\n\
	\n\
	for {set i 0} {$i<5} {incr i} {\n\
	    frame .web.f0.active$i -width 5 -height 10 -bg white\n\
	    pack .web.f0.active$i -side left\n\
	}\n\
	label .web.f0.l -text \"Status:\"\n\
	pack .web.f0.l -side left\n\
	set webstatus \"Looking up address\"\n\
	label .web.f0.s -text $webstatus\n\
	pack .web.f0.s -side left\n\
	frame .web.f1 -borderwidth 2 -relief groove\n\
	pack .web.f1 -side top -fill x\n\
	label .web.f1.l -text \"Location:\"\n\
	pack .web.f1.l -side left\n\
	entry .web.f1.e -width 40 -relief sunken -borderwidth 2\n\
	bind .web.f1.e <Return> {\n\
	    webdisp [.web.f1.e get]\n\
	}\n\
	pack .web.f1.e -side left -fill x -expand true\n\
	frame .web.f2 -borderwidth 2 -relief groove\n\
	pack .web.f2 -side top -fill x\n\
	button .web.f2.back -text Back \\\n\
	    -command {incr uriix -1; webdisp2}\n\
	pack .web.f2.back -side left -fill x -expand true\n\
	button .web.f2.forw -text Forward \\\n\
	    -command {incr uriix; webdisp2}\n\
	pack .web.f2.forw -side left -fill x -expand true\n\
	button .web.f2.stop -text Stop -command {stop_www_loading}\n\
	pack .web.f2.stop -side left -fill x -expand true\n\
	button .web.f2.dismiss -text Dismiss -command {stop_www_loading; destroy .web}\n\
	pack .web.f2.dismiss -side left -fill x -expand true\n\
	set uriix -1\n\
	set urilist {}\n\
    }\n\
    # If there's no colon, or if the colon is followed by a port number and\n\
    # potentially a pathname, then add the missing \"http://\" .\n\
    if {[string first \":\" $uri]==-1 || [regexp {^[^:]+:[0-9]+(|/.*)$} $uri]} {\n\
	set uri \"http://$uri\"\n\
    }\n\
    set urilist [lrange $urilist 0 $uriix]\n\
    lappend urilist $uri\n\
    incr uriix\n\
    webdisp2\n\
}\n\
\n\
# webdisp2 only ever displays $urilist[$uriix]\n\
proc webdisp2 {} {\n\
    global urilist uriix webproxy webstatus\n\
\n\
    set webstatus \"Looking up address\"\n\
    .web.f0.s configure -text $webstatus\n\
    update\n\
    .web.f2.stop configure -state normal\n\
    if {$uriix==-1} {\n\
	puts \"webdisp2 called with no url\"\n\
	return\n\
    } \n\
    if {$uriix==0} {\n\
	.web.f2.back configure -state disabled\n\
    } else {\n\
	.web.f2.back configure -state normal\n\
    }\n\
    if {$uriix<[expr [llength $urilist]-1]} {\n\
	.web.f2.forw configure -state normal\n\
    } else {\n\
	# Range checking\n\
	if {$uriix>[expr [llength $urilist] -1]} {\n\
		puts \"webdisp2 had to reset uriix\"\n\
	    set uriix [expr [llength $urilist] -1]\n\
	}\n\
	.web.f2.forw configure -state disabled\n\
    }\n\
    set uri [lindex $urilist $uriix]\n\
    set str [webto $uri $webproxy]\n\
    .web.f2.stop configure -state disabled\n\
    set webstatus \"Parsing\"\n\
    .web.f0.s configure -text $webstatus\n\
    show_inactive\n\
    update\n\
#    puts \"uriix=$uriix\"\n\
#    puts \"urilist=$urilist\"\n\
    .web.f1.e delete 0 end\n\
    .web.f1.e insert 0 $uri\n\
    .web.f.c configure -state normal\n\
    .web.f.c delete 1.0 end\n\
    wm title .web \"WWW browser\"\n\
    #parse the header\n\
    #\n\
    # Some bonehead web servers forget to reply with HTTP 1.0 headers\n\
    # in certain situations.  Guess using bogus heuristic:\n\
    if {[string index $str 0]==\"<\"} {\n\
	set header \"Content-type: text/html\\n\"\n\
	set data $str\n\
    } else {\n\
	set hend [string first \"\\r\\n\\r\\n\" $str]\n\
#	puts $hend\n\
	if {$hend==-1} {\n\
	    set hend [string first \"\\n\\n\" $str]\n\
	    if {$hend==-1} {\n\
		puts \"Failed to find CRLFCRLF or LFLF in header!\"\n\
		puts [split [string range $str 0 400] \"\\n\"]\n\
		set data \"Failed to find CRLFCRLF or LFLF in header!\"\n\
	    } else {\n\
		set data [string range $str [expr $hend + 2] end]\n\
	    }\n\
	} else {\n\
	    set data [string range $str [expr $hend + 4] end]\n\
	}\n\
	set header [string range $str 0 $hend]\n\
    }\n\
\n\
    set ctype text\n\
    set cstype html\n\
    set hlist [split $header \"\\n\"]\n\
    set redirect 0\n\
    foreach h $hlist {\n\
	set h [string trim $h \"\\r\"]\n\
	set field [string tolower [lindex [split $h \":\"] 0]]\n\
	set value [string trim [lindex [split $h \":\"] 1] \" \"]\n\
#	puts \"->$field<->$value<-\"\n\
	if {$field == \"content-type\"} {\n\
	    set ctype [lindex [split $value \"/\"] 0]\n\
	    set cstype [lindex [split $value \"/\"] 1]\n\
	} elseif {$field == \"location\"} {\n\
	    set redirect \\\n\
		[string trim [join [lrange [split $h \":\"] 1 end] \":\"] \" \"]\n\
	}\n\
    }\n\
    if {$redirect != 0} {\n\
	set urilist [lreplace $urilist $uriix $uriix $redirect]\n\
	webdisp2\n\
	return\n\
    }\n\
    if {$ctype != \"text\"} {\n\
	if {$ctype==\"image\"} {\n\
	    msgpopup \"Starting external viewer\" \"Data is an image\"\n\
	    save_www_data_to_file [expr $hend + 4] /tmp/sdrimage\n\
	    exec xv /tmp/sdrimage &\n\
	} else {\n\
	    # Server CERN/3.0pre6 uses content-type \"www/unknown\"\n\
	    # for error messages!  How to handle this??\n\
	    msgpopup \"Invalid Content Type\" \"$ctype/$cstype is not a text type\"\n\
	    set webstatus \"Finished\"\n\
	    .web.f0.s configure -text $webstatus\n\
	    return\n\
	}\n\
    }\n\
    if {$cstype == \"plain\"} {\n\
	.web.f.c insert 1.0 $data\n\
	highlight_url .web.f.c 1\n\
	.web.f.c configure -state disabled\n\
    } elseif {$cstype==\"html\"} {\n\
	parse_html .web.f.c $data \n\
	if {[regexp {#(.*)$} $uri junk anchor]} {\n\
	    set anchor \"M$anchor\"\n\
	    catch {.web.f.c yview $anchor}\n\
	}\n\
    }\n\
    set webstatus \"Finished\"\n\
    .web.f0.s configure -text $webstatus\n\
    wm minsize .web 1 1\n\
}\n\
\n\
proc webstatus {} {\n\
    global webstatus\n\
    #the things we do to get around broken Tcl_Eval calls!\n\
    .web.f0.s configure -text $webstatus\n\
}\n\
\n\
set statctr 0\n\
proc show_active {} {\n\
    global statctr\n\
    .web.f0.active$statctr configure -background white\n\
    incr statctr\n\
    if {$statctr==5} {set statctr 0}    \n\
    .web.f0.active$statctr configure -background blue\n\
}\n\
proc show_inactive {} {\n\
    global statctr\n\
    .web.f0.active$statctr configure -background white\n\
}\n\
\n\
proc overhref {{href {}}} {\n\
    global webstatus\n\
\n\
    if {$href == {}} {\n\
	.web.f0.s configure -text $webstatus\n\
    } else {\n\
	.web.f0.s configure -text $href\n\
    }\n\
}\n\
\n\
proc parse_html {win data} {\n\
    global uriix urilist href\n\
    set type normal\n\
    set ptype normal\n\
    set normal normal\n\
    set ltype ul\n\
    set href 0\n\
    set refnum 0\n\
    set break 1\n\
    set space 2\n\
    set listindent 0\n\
    set bulletnum 0\n\
    set fontstack normal\n\
    $win insert end \" \"\n\
    $win tag configure h1 -font \"-*-times-bold-r-normal--24-*\"\n\
    $win tag configure h2 -font \"-*-times-bold-r-normal--18-*\"\n\
    $win tag configure h3 -font \"-*-times-bold-r-normal--14-*\"\n\
    $win tag configure h4 -font \"-*-times-bold-r-normal--14-*\"\n\
    $win tag configure b -font \"-*-times-bold-r-normal--14-*\"\n\
    $win tag configure i -font \"-*-times-medium-i-normal--14-*\"\n\
    $win tag configure address -font \"-*-times-medium-i-normal--14-*\"\n\
    $win tag configure normal -font \"-*-times-medium-r-normal--14-*\"\n\
    $win tag configure pre -font \"-*-courier-medium-r-normal--14-*\"\n\
    $win tag configure ref -foreground blue\n\
    $win tag configure dd -lmargin1 40 -lmargin2 40\n\
    $win tag configure center -justify center\n\
\n\
    regsub -all \"\\r\\n\" $data \"\\n\" data\n\
    # Some web servers violate HTTP and send \\r-seperated lines\n\
    regsub -all \"\\r\" $data \"\\n\" data\n\
    while {$data!=\"\"} {\n\
#	puts [string length $data]\n\
	set ix1 [string first \"<\" $data]\n\
	set cur [$win index \"end - 1 chars\"]\n\
	if {$type==\"title\"} {\n\
	    wm title .web [string range $data 0 [expr $ix1-1]]\n\
	} else {\n\
	    set idata [string range $data 0 [expr $ix1-1]]\n\
	    if {$break==1} {\n\
                set llist [split $idata \"\\n\\r\"]\n\
                set idata \"\"\n\
                foreach line $llist {\n\
		    if {$line!=\"\"} {\n\
			if {$idata==\"\"} {\n\
			    # Note that source HTML like\n\
			    #\n\
			    # 		<A HREF=\"foo\">foo</A>\n\
			    #		blah\n\
			    #\n\
			    # will get rendered like\n\
			    #\n\
			    # foo		blah\n\
			    #\n\
			    # because of the following if.\n\
			    #\n\
			    if {$space>0} {\n\
				set line [string trimleft $line \" \\t\"]\n\
			    }\n\
			    set idata $line\n\
			} else {\n\
			    set line [string trimleft $line \" \\t\"]\n\
			    set idata \"$idata $line\"\n\
			}\n\
		    }\n\
		}\n\
	    } \n\
	    if {([string trim $idata \" \\t\"]!=\"\")||($break==0)} {\n\
		$win insert end [parse_for_escaped_chars $idata]\n\
		set space 0\n\
	    }\n\
	    $win tag remove $ptype $cur end\n\
	    if {$type!=\"normal\"} {\n\
		update\n\
		$win tag add $type $cur end\n\
		set ptype $type\n\
	    }\n\
	    if {$href!=0} {\n\
		$win tag configure ref$refnum -foreground blue\n\
		$win tag bind ref$refnum <1> \\\n\
		    \"webdisp {$href}\"\n\
		$win tag bind ref$refnum <Enter> \\\n\
		    \"$win tag configure ref$refnum -foreground \\\n\
                     [option get . activehotForeground Sdr];\\\n\
		     overhref {$href}\"\n\
		$win tag bind ref$refnum <Leave> \\\n\
		    \"$win tag configure ref$refnum -foreground \\\n\
                     [option get . hotForeground Sdr];\\\n\
		     overhref\"\n\
		$win tag add ref$refnum $cur end\n\
	    } else {\n\
		$win tag remove ref$refnum $cur end\n\
	    }\n\
	}\n\
	set ix2 [string first \">\" $data]\n\
	set tag [string range $data [expr $ix1+1] [expr $ix2-1]]\n\
	if {$ix2!=-1} {\n\
	    set data [string range $data [expr $ix2+1] end]\n\
	} else {\n\
	    $win insert end [parse_for_escaped_chars $data]\n\
	    $win configure -state disabled\n\
	    return\n\
	}\n\
	set tname [lindex [split $tag \" \\n\\r\\t\"] 0]\n\
	set tname [string tolower $tname]\n\
	set cur [$win index \"end - 1 chars\"]\n\
	if {$tname==\"base\"} {\n\
	    set base [parseref $tag]\n\
\n\
	    if {$base != 0} {\n\
		.web.f1.e delete 0 end\n\
		.web.f1.e insert 0 $base\n\
		set urilist [lreplace $urilist $uriix $uriix $base]\n\
	    }\n\
	} elseif {$tname==\"meta\"} {\n\
	    # People seem to tend to use\n\
	    # <META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=url\">\n\
	    # instead of document redirects.  ARGH!\n\
	    #\n\
	    # Technically, this really should pretend that it's just another\n\
	    # header & the header parser should be expanded, but this is the\n\
	    # easy 90% case!\n\
	    if {[parsestr $tag \"http-equiv\" equiv] && $equiv==\"Refresh\"} {\n\
		if [parsestr $tag \"content\" content] {\n\
		    if {[parsestr $content \"url\" newurl] && $newurl != {}} {\n\
			regexp {^([0-9]+);} $content foo delay\n\
#			puts \"Refresh after $delay seconds to $newurl\"\n\
			if {$delay == 0} {\n\
			    set urilist [lreplace $urilist $uriix $uriix $newurl]\n\
			    webdisp2\n\
			    return\n\
			} else {\n\
			    after [expr $delay*1000] webrefresh $newurl \\\n\
				[lindex $urilist $uriix]\n\
			}\n\
		    }\n\
		}\n\
	    }\n\
	} elseif {$tname==\"p\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    rmtags $win $cur end\n\
	    set data [string trimleft $data \" \"]\n\
	} elseif {$tname==\"hr\"} {\n\
	    addspace $win 2 $space\n\
	    $win insert end \"--------\\n\"\n\
	    set space 1\n\
	    set data [string trimleft $data \" \"]\n\
     	} elseif {$tname==\"a\"} {\n\
	    set href [fixuri [parseref $tag]]\n\
	    if [parsestr $tag \"name\" mark] {\n\
		set mark \"M$mark\"\n\
		$win mark set $mark $cur\n\
		$win mark gravity $mark left\n\
	    }\n\
#	    set space 0\n\
	    incr refnum\n\
     	} elseif {$tname==\"/a\"} {\n\
	    set href 0\n\
     	} elseif {$tname==\"address\"} {\n\
	    set space [addspace $win 1 $space]\n\
	    set type $tname\n\
     	} elseif {$tname==\"/address\"} {\n\
	    set type $normal\n\
     	} elseif {$tname==\"h1\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $tname\n\
	    set data [string trimleft $data \" \"]\n\
	    set fontstack h1\n\
	} elseif {$tname==\"h2\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $tname\n\
	    set data [string trimleft $data \" \"]\n\
	    set fontstack h2\n\
	} elseif {$tname==\"h3\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $tname\n\
	    set data [string trimleft $data \" \"]\n\
	    set fontstack h3\n\
	} elseif {$tname==\"h4\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $tname\n\
	    set data [string trimleft $data \" \"]\n\
	    set fontstack h3\n\
	} elseif {$tname==\"/h1\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set data [string trimleft $data \" \"]\n\
	    set fontstack normal\n\
	} elseif {$tname==\"/h2\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set data [string trimleft $data \" \"]\n\
	    set fontstack normal\n\
	} elseif {$tname==\"/h3\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set data [string trimleft $data \" \"]\n\
	    set fontstack normal\n\
	} elseif {$tname==\"/h4\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set data [string trimleft $data \" \"]\n\
	    set fontstack normal\n\
	} elseif {$tname==\"br\" || $tname==\"/br\"} {\n\
	    # Sigh, netscape treats </br> as <br> so people will use it\n\
	    set space [addspace $win 1 $space]\n\
	    set data [string trimleft $data \" \"]\n\
	} elseif {$tname==\"img\"} {\n\
	    #is there an alternate text string\n\
	    if [parsestr $tag \"alt\" alt] {\n\
		$win insert end $alt\n\
	    } else {\n\
		#is it an active map (can't do them!)\n\
		set ix [string first \"ismap\" [string tolower $tag]]\n\
		if {$ix!=-1} {\n\
		    set href 0\n\
		    $win insert end \"\\[ACTIVE MAP\\]\"\n\
		} else {\n\
		    $win insert end \"\\[IMAGE\\]\"\n\
		}\n\
	    }\n\
	    rmtags $win $cur end\n\
\n\
\n\
\n\
	    if {$href!=0} {\n\
                $win tag add ref$refnum $cur end\n\
                $win tag configure ref$refnum -foreground blue\n\
                $win tag bind ref$refnum <1> \\\n\
                    \"webdisp $href\"\n\
            }\n\
	    set space 0\n\
	} elseif {$tname==\"dl\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set ltype dl\n\
	    incr listindent\n\
	} elseif {$tname==\"/dl\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set ltype ul\n\
	    incr listindent -1\n\
	} elseif {$tname==\"dt\"} {\n\
	    set space [addspace $win 2 $space]\n\
            set type $normal\n\
	} elseif {$tname==\"dd\"} {\n\
	    set space [addspace $win 1 $space]\n\
            set type $tname\n\
	} elseif {$tname==\"ul\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set ltype ul\n\
	    incr listindent\n\
	} elseif {$tname==\"/ul\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set ltype ul\n\
	    incr listindent -1\n\
	} elseif {$tname==\"menu\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set ltype ul\n\
	    incr listindent\n\
	} elseif {$tname==\"/menu\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set ltype ul\n\
	    incr listindent -1\n\
	} elseif {$tname==\"ol\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set ltype ol\n\
	    set lnum 1\n\
	    incr listindent\n\
	} elseif {$tname==\"/ol\"} {\n\
	    set space [addspace $win 2 $space]\n\
	    set type $normal\n\
	    set ltype ul\n\
	    incr listindent -1\n\
	} elseif {$tname==\"li\"} {\n\
	    set space [addspace $win 1 $space]\n\
	    for {set ind 1} {$ind < $listindent} {incr ind} {\n\
		$win insert end \"  \"\n\
	    }\n\
	    if {$ltype==\"ul\"} { \n\
		if {$listindent==1} {\n\
                    $win window create end -create \"label $win.bullet$bulletnum -bitmap bullet0\"\n\
                    incr bulletnum\n\
		} else {\n\
                    $win window create end -create \"label $win.bullet$bulletnum -bitmap bullet1\"		\n\
                    incr bulletnum\n\
		}\n\
		rmtags $win $cur end\n\
		set data [string trimleft $data \" \\n\\t\\r\"]\n\
	    } elseif {$ltype==\"ol\"} {\n\
		$win insert end \" $lnum. \"\n\
		rmtags $win $cur end\n\
		set data [string trimleft $data \" \\n\\t\\r\"]\n\
		incr lnum\n\
	    }\n\
	} elseif {$tname==\"/b\"} {\n\
	    if {[lindex $fontstack 0]==\"b\"} {\n\
		set type normal\n\
		catch {\n\
		    set type [lindex $fontstack 1]\n\
		    set fontstack [lrange $fontstack 1 end]\n\
		}\n\
	    } else {\n\
		set type normal\n\
	    }\n\
#	    set space 0\n\
	} elseif {$tname==\"/i\"} {\n\
	    if {[lindex $fontstack 0]==\"i\"} {\n\
		set type normal\n\
		catch {\n\
		    set type [lindex $fontstack 1]\n\
		    set fontstack [lrange $fontstack 1 end]\n\
		}\n\
	    } else {\n\
		set type normal\n\
	    }\n\
#	    set space 0\n\
	} elseif {$tname==\"pre\"} {\n\
	    set type $tname\n\
	    set break 0\n\
	    set space [addspace $win 1 0]\n\
	    set fontstack pre\n\
	} elseif {$tname==\"/pre\"} {\n\
	    set type normal\n\
	    set break 1\n\
	    set space [addspace $win 1 0]\n\
	    set fontstack normal\n\
	} elseif {$tname==\"!\"} {\n\
	    # do anything here, or just completely ignore?\n\
	} elseif {$tname==\"!doctype\"} {\n\
	    # do nothing.\n\
	} elseif {[string match \"!--*\" $tname]} {\n\
	    # A comment may have embedded HTML; if the end of the tag\n\
	    # is not \"--\" then find the real end tag.\n\
	    # Note that this doesn't parse \"<!-- foo -- >\" properly\n\
	    if {[string range $tag [expr [string length $tag]-2] end] != \"--\"} {\n\
		set cix [string first \"-->\" $data]\n\
		if {$cix != -1} {\n\
		    set data [string range $data [expr $cix+3] end]\n\
		}\n\
	    }\n\
	} elseif {$tname==\"b\"} {\n\
	    set type $tname\n\
	    if {[lindex $fontstack 0]!=\"b\"} {\n\
		set fontstack \"b $fontstack\"\n\
	    }\n\
	} elseif {$tname==\"i\"} {\n\
	    set type $tname\n\
	    if {[lindex $fontstack 0]!=\"i\"} {\n\
		set fontstack \"i $fontstack\"\n\
	    }\n\
	} else {\n\
	    set type $tname\n\
#	    set space 0\n\
	}\n\
    }\n\
    $win configure -state disabled\n\
}\n\
\n\
proc addspace {win num space} {\n\
    set cur [$win index \"end - 1 chars\"]\n\
    while {$num > $space} {\n\
	$win insert end \"\\n\"\n\
	incr space\n\
    }\n\
    rmtags $win $cur end\n\
    return $space\n\
}\n\
proc gohome {} {\n\
    global home uriix urilist\n\
\n\
    webdisp $home\n\
}\n\
proc rmtags {win p1 p2} {\n\
    set tlist [$win tag names $p1]\n\
    foreach t $tlist {\n\
	$win tag remove $t $p1 $p2\n\
    }\n\
}\n\
\n\
proc parseref {ref} {\n\
    if {[parsestr $ref \"href\" tmp]==0} {\n\
	return 0\n\
    } else {\n\
	return $tmp\n\
    }\n\
}\n\
\n\
# parsestr returns the value for a particular key/value pair\n\
# attempting to allow optional quoting and the always-forgotten\n\
# trailing quote.\n\
#\n\
# parsestr returns the value in the variable $ret, and returns\n\
# 1 if it found a match or 0 if it failed.\n\
#\n\
# XXX todo: remove regexp special characters from $key\n\
proc parsestr {str key ret} {\n\
    if {[regexp -nocase \"^(.*\\[ \\t\\r\\n]+)?${key}\\[ \\t\\r\\n=]+(.*)$\" $str \\\n\
		junk junk2 str]==0} {uplevel \"set $ret {}\"; return 0}\n\
\n\
    if {[regexp {^\"([^\"]*)\"?} $str junk tmp]} {\n\
	uplevel \"set $ret {$tmp}\"\n\
    } else {\n\
	uplevel \"set $ret {[lindex [split $str] 0]}\"\n\
    }\n\
    return 1\n\
}\n\
\n\
proc webrefresh {newurl cururl} {\n\
    global uriix urilist\n\
\n\
    if {$cururl != [lindex $urilist $uriix]} {\n\
#	puts \"Refreshing from $cururl to $newurl failed because we're on [lindex $urilist $uriix] now\"\n\
	# We're not currently on the page that the refresh belongs to\n\
	return\n\
    } else {\n\
#	puts \"Refreshing from $cururl to $newurl\"\n\
	# If it's a different URL, then add it to the history\n\
	# If it's the same URL, just re-display it\n\
	if [string compare $cururl $newurl] {\n\
	    webdisp $newurl\n\
	} else {\n\
	    webdisp2\n\
	}\n\
    }\n\
}\n\
\n\
proc getprevuri {} {\n\
    global uriix urilist\n\
#    put $urilist\n\
    return [lindex $urilist [expr $uriix-1]]\n\
}\n\
\n\
proc getnexturi {} {\n\
    global uriix urilist\n\
#    puts $urilist\n\
    if {[llength $urilist] > $uriix} {\n\
	return [lindex $urilist [expr $uriix+1]]\n\
    } else {\n\
	return [lindex $urilist $uriix]\n\
    }\n\
}\n\
\n\
proc fixuri {uri} {\n\
    global uriix urilist\n\
    if {$uri==0} {return 0}\n\
\n\
    set ix [string first \"://\" $uri]\n\
    if {$ix > -1} {\n\
	if {[string index $uri 0]!=\"/\"} {\n\
	    return $uri\n\
	}\n\
    }\n\
    if {[string range $uri 0 4]==\"help:\"} {return $uri}\n\
    if {[string range $uri 0 6]==\"mailto:\"} {return $uri}\n\
    #break up the current url\n\
    set cururi [lindex [split [lindex $urilist $uriix] \"#\"] 0]\n\
    set ix [string first \"://\" $cururi]\n\
    set proto [string range $cururi 0 [expr $ix-1]]\n\
    set host [string range $cururi [expr $ix+3] end]\n\
    set ix [string first \"/\" $host]\n\
    if {$ix!=-1} {\n\
	set path [string range $host [expr $ix+1] end]\n\
	set host [string range $host 0 [expr $ix-1]]\n\
    } else {\n\
	set path \"\"\n\
    }\n\
    # Have to parse host-less URL's like http:/foo/bar/baz\n\
\n\
    #there's no protocol field present\n\
    if {[lindex [split $uri \"#\"] 0]==\"\"} {\n\
	#it's in the same file\n\
	return \"$cururi$uri\"\n\
    } elseif {[string index $uri 0]!=\"/\"} {\n\
	#it's a relative filename\n\
	set dropctr 1\n\
	while {[string range $uri 0 2]==\"../\"} {\n\
	    incr dropctr\n\
	    set uri [string range $uri 3 end]\n\
	}\n\
	set plist [split $path \"/\"]\n\
	set plist [lrange $plist 0 [expr [llength $plist]-($dropctr+1)]]\n\
	lappend plist $uri\n\
	set path [join $plist \"/\"]\n\
	return \"$proto://$host/$path\"\n\
    } elseif {[string index $uri 1]!=\"/\"} {\n\
	#it's an absolute filename\n\
	return \"$proto://$host$uri\"\n\
    } else {\n\
	#only the proto is missing\n\
	return \"$proto:$uri\"\n\
    }\n\
}\n\
\n\
proc parse_for_escaped_chars {data} {\n\
    set result \"\"\n\
    while {[string first \"&\" $data]!=-1} {\n\
	set ix [string first \"&\" $data]\n\
	set result $result[string range $data 0 [expr $ix-1]]\n\
	set data [string range $data $ix end]\n\
	set ix2  [string first \";\" $data]\n\
	if {$ix2 == -1} {\n\
	    break;\n\
	}\n\
	set esc [string range $data 0 $ix2]\n\
	set data [string range $data [expr $ix2+1] end]    \n\
	switch -regexp $esc {\n\
	    {^&quot;$} {set result \"$result''\"}\n\
            {^&AElig;$} {set result [format \"%s%c\" $result 198]}\n\
            {^&Aacute;$} {set result [format \"%s%c\" $result 193]}\n\
            {^&Acirc;$} {set result [format \"%s%c\" $result 194]}\n\
            {^&Agrave;$} {set result [format \"%s%c\" $result 192]}\n\
            {^&Aring;$} {set result [format \"%s%c\" $result 197]}\n\
            {^&Atilde;$} {set result [format \"%s%c\" $result 195]}\n\
            {^&Auml;$} {set result [format \"%s%c\" $result 196]}\n\
            {^&Ccedil;$} {set result [format \"%s%c\" $result 199]}\n\
            {^&ETH;$} {set result [format \"%s%c\" $result 208]}\n\
            {^&Eacute;$} {set result [format \"%s%c\" $result 201]}\n\
            {^&Ecirc;$} {set result [format \"%s%c\" $result 202]}\n\
            {^&Egrave;$} {set result [format \"%s%c\" $result 200]}\n\
            {^&Euml;$} {set result [format \"%s%c\" $result 203]}\n\
            {^&Iacute;$} {set result [format \"%s%c\" $result 205]}\n\
            {^&Icirc;$} {set result [format \"%s%c\" $result 206]}\n\
            {^&Igrave;$} {set result [format \"%s%c\" $result 204]}\n\
            {^&Iuml;$} {set result [format \"%s%c\" $result 207]}\n\
            {^&Ntilde;$} {set result [format \"%s%c\" $result 209]}\n\
            {^&Oacute;$} {set result [format \"%s%c\" $result 211]}\n\
            {^&Ocirc;$} {set result [format \"%s%c\" $result 212]}\n\
            {^&Ograve;$} {set result [format \"%s%c\" $result 210]}\n\
            {^&Oslash;$} {set result [format \"%s%c\" $result 216]}\n\
            {^&Otilde;$} {set result [format \"%s%c\" $result 213]}\n\
            {^&Ouml;$} {set result [format \"%s%c\" $result 214]}\n\
            {^&THORN;$} {set result [format \"%s%c\" $result 222]}\n\
            {^&Uacute;$} {set result [format \"%s%c\" $result 218]}\n\
            {^&Ucirc;$} {set result [format \"%s%c\" $result 219]}\n\
            {^&Ugrave;$} {set result [format \"%s%c\" $result 217]}\n\
            {^&Uuml;$} {set result [format \"%s%c\" $result 220]}\n\
            {^&Yacute;$} {set result [format \"%s%c\" $result 221]}\n\
            {^&aacute;$} {set result [format \"%s%c\" $result 225]}\n\
            {^&acirc;$} {set result [format \"%s%c\" $result 226]}\n\
            {^&acute;$} {set result [format \"%s%c\" $result 180]}\n\
            {^&aelig;$} {set result [format \"%s%c\" $result 230]}\n\
            {^&agrave;$} {set result [format \"%s%c\" $result 224]}\n\
            {^&amp;$} {set result [format \"%s%c\" $result 38]}\n\
            {^&aring;$} {set result [format \"%s%c\" $result 229]}\n\
            {^&atilde;$} {set result [format \"%s%c\" $result 227]}\n\
            {^&auml;$} {set result [format \"%s%c\" $result 228]}\n\
            {^&brvbar;$} {set result [format \"%s%c\" $result 166]}\n\
            {^&ccedil;$} {set result [format \"%s%c\" $result 231]}\n\
            {^&cedil;$} {set result [format \"%s%c\" $result 184]}\n\
            {^&cent;$} {set result [format \"%s%c\" $result 162]}\n\
            {^&copy;$} {set result [format \"%s%c\" $result 169]}\n\
            {^&curren;$} {set result [format \"%s%c\" $result 164]}\n\
            {^&deg;$} {set result [format \"%s%c\" $result 176]}\n\
            {^&divide;$} {set result [format \"%s%c\" $result 247]}\n\
            {^&eacute;$} {set result [format \"%s%c\" $result 233]}\n\
            {^&ecirc;$} {set result [format \"%s%c\" $result 234]}\n\
            {^&egrave;$} {set result [format \"%s%c\" $result 232]}\n\
            {^&eth;$} {set result [format \"%s%c\" $result 240]}\n\
            {^&euml;$} {set result [format \"%s%c\" $result 235]}\n\
            {^&frac12;$} {set result [format \"%s%c\" $result 189]}\n\
            {^&frac14;$} {set result [format \"%s%c\" $result 188]}\n\
            {^&frac34;$} {set result [format \"%s%c\" $result 190]}\n\
            {^&gt;$} {set result [format \"%s%c\" $result 62]}\n\
            {^&iacute;$} {set result [format \"%s%c\" $result 237]}\n\
            {^&icirc;$} {set result [format \"%s%c\" $result 238]}\n\
            {^&iexcl;$} {set result [format \"%s%c\" $result 161]}\n\
            {^&igrave;$} {set result [format \"%s%c\" $result 236]}\n\
            {^&iquest;$} {set result [format \"%s%c\" $result 191]}\n\
            {^&iuml;$} {set result [format \"%s%c\" $result 239]}\n\
            {^&laquo;$} {set result [format \"%s%c\" $result 171]}\n\
            {^&lt;$} {set result [format \"%s%c\" $result 60]}\n\
            {^&macr;$} {set result [format \"%s%c\" $result 175]}\n\
            {^&micro;$} {set result [format \"%s%c\" $result 181]}\n\
            {^&middot;$} {set result [format \"%s%c\" $result 183]}\n\
            {^&nbsp;$} {set result [format \"%s%c\" $result 32]}\n\
            {^&not;$} {set result [format \"%s%c\" $result 172]}\n\
            {^&ntilde;$} {set result [format \"%s%c\" $result 241]}\n\
            {^&oacute;$} {set result [format \"%s%c\" $result 243]}\n\
            {^&ocirc;$} {set result [format \"%s%c\" $result 244]}\n\
            {^&ograve;$} {set result [format \"%s%c\" $result 242]}\n\
            {^&ordf;$} {set result [format \"%s%c\" $result 170]}\n\
            {^&ordm;$} {set result [format \"%s%c\" $result 186]}\n\
            {^&oslash;$} {set result [format \"%s%c\" $result 248]}\n\
            {^&otilde;$} {set result [format \"%s%c\" $result 245]}\n\
            {^&ouml;$} {set result [format \"%s%c\" $result 246]}\n\
            {^&para;$} {set result [format \"%s%c\" $result 182]}\n\
            {^&plusmn;$} {set result [format \"%s%c\" $result 177]}\n\
            {^&pound;$} {set result [format \"%s%c\" $result 163]}\n\
            {^&raquo;$} {set result [format \"%s%c\" $result 187]}\n\
            {^&reg;$} {set result [format \"%s%c\" $result 174]}\n\
            {^&sect;$} {set result [format \"%s%c\" $result 167]}\n\
            {^&shy;$} {set result [format \"%s%c\" $result 173]}\n\
            {^&sup1;$} {set result [format \"%s%c\" $result 185]}\n\
            {^&sup2;$} {set result [format \"%s%c\" $result 178]}\n\
            {^&sup3;$} {set result [format \"%s%c\" $result 179]}\n\
            {^&szlig;$} {set result [format \"%s%c\" $result 223]}\n\
            {^&thorn;$} {set result [format \"%s%c\" $result 254]}\n\
            {^&times;$} {set result [format \"%s%c\" $result 215]}\n\
            {^&uacute;$} {set result [format \"%s%c\" $result 250]}\n\
            {^&ucirc;$} {set result [format \"%s%c\" $result 251]}\n\
            {^&ugrave;$} {set result [format \"%s%c\" $result 249]}\n\
            {^&uml;$} {set result [format \"%s%c\" $result 168]}\n\
            {^&uuml;$} {set result [format \"%s%c\" $result 252]}\n\
            {^&yacute;$} {set result [format \"%s%c\" $result 253]}\n\
            {^&yen;$} {set result [format \"%s%c\" $result 165]}\n\
            {^&yuml;$} {set result [format \"%s%c\" $result 255]}\n\
            {^&#[0-9]+;$} {regexp {0*([0-9]+)} $esc junk tmp\n\
                         set result [format \"%s%c\" $result $tmp]}\n\
	    default {set result [format \"%s%c\" $result 38]\n\
		     set data [string range $esc 1 end]$data}\n\
	}\n\
    }\n\
    set result $result$data\n\
    return $result\n\
}\n\
";
